Index: mscore/mscore/text.cpp
===================================================================
--- mscore/mscore/text.cpp	(revision 4338)
+++ mscore/mscore/text.cpp	(working copy)
@@ -407,13 +407,26 @@
             c.cursorPosition = cursor->position();
             }
       QColor color;
-      if (painter->view() && !painter->view()->editMode() && !(score() && score()->printing())) {
-            color = QColor(
-               (selected() && !(score() && score()->printing()))
-               ? preferences.selectColor[0] : style().foregroundColor());
-            }
+//      if (painter->view() && !painter->view()->editMode() && !(score() && score()->printing())) {
+//            color = QColor(
+//               (selected() && !(score() && score()->printing()))
+//               ? preferences.selectColor[0] : style().foregroundColor());
+//            }
+//      else
+//            color = QColor(visible() ? style().foregroundColor() : Qt::gray);
+      // if printing, use own colour if visible, do nothing if invisible
+      if(score() && score()->printing()) {
+            if(visible())
+                  color = style().foregroundColor();
+            else
+                  return;
+      }
+      // if editing, unconditionally use selection colour
+      else if(painter->view() && painter->view()->editMode())
+            color = preferences.selectColor[0];
       else
-            color = QColor(visible() ? style().foregroundColor() : Qt::gray);
+      // by default, use selection color if selected; if not, use own colour if visible or in gray if invisible
+            color = selected() ? preferences.selectColor[0] : (visible() ? style().foregroundColor() : Qt::gray);
       c.palette.setColor(QPalette::Text, color);

       _doc->documentLayout()->draw(&p, c);
